using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;
using Exferia_Maestros.General;
using Exferia_General;
using Exferia_Maestros._0_Modelos;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;

namespace Exferia_Maestros._3_Vistas.Listados
{
    public class ABS_Listado_MAE_Articulos_Embalajes_Precios_Historico_P_Articulo_AUX_1 : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_MAE_Articulos_Embalajes_Precios_Historico_P_Articulo_AUX_1()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, false, false, "", null));

            //Fecha_Inicial
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Fecha_Inicial), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Fecha_Inicial), "Inicio", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 120, true, true, true, false, "", null,false));
            //Fecha_Final
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Fecha_Final), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Fecha_Final), "Fin", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 120, true, true, true, false, "", null, false));

            //Embalaje
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMBALAJE = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idEmbalaje), nameof(MAE_Embalajes), nameof(MAE_Embalajes.id), nameof(MAE_Embalajes.codigo), nameof(MAE_Embalajes.descripcion), nameof(MAE_Embalajes.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Embalaje), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Embalaje), "Embalaje", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, true, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMBALAJE));

            //NomenclaturaPrecio
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_NOMENCLATURAPRECIO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idNomenclaturaPrecio), nameof(MAE_NomenclaturasPrecios), nameof(MAE_NomenclaturasPrecios.id), nameof(MAE_NomenclaturasPrecios.codigo), nameof(MAE_NomenclaturasPrecios.descripcion), nameof(MAE_NomenclaturasPrecios.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.NomenclaturaPrecio), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.NomenclaturaPrecio), "Nomenclatura", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, true, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_NOMENCLATURAPRECIO));

            //precio
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.precio), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.precio), "Precio", Enumerados.G_ENUM_TIPOSDATOS.DECIMAL, false, 150, true, true, true, false, "", null));
           
            //Empresa
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idEmpresa), nameof(GEN_Empresas), nameof(GEN_Empresas.id), nameof(GEN_Empresas.codigo), nameof(GEN_Empresas.descripcion), nameof(GEN_Empresas.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Empresa), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Empresa), "Empresa", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA));

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_MAE_ARTICULO_AUX_1_EMBALAJE_PRECIO_HISTORICO);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_MAE_ARTICULO_AUX_1_EMBALAJE_PRECIO_HISTORICO;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.fechaHora);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "1";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
